package de.hampelratte.yaggui;

import java.util.Vector;

/**
 * This is a wrapper class to store and display the result hashtable in a table
 */
public class Result {
    private Command cmd;

    private Vector resultsVector = new Vector();

    public Result(Command cmd) {
        this.cmd = cmd;
    }

    private String getName() {
        String path = (String) cmd.get("file");
        String name = path.substring(path.lastIndexOf("/") + 1, path.length());
        return name;
    }

    public void put(String key, Object value) {
        cmd.put(key, value);
    }

    public Object get(String key) {
        return cmd.get(key);
    }

    public Command getCommand() {
        return cmd;
    }

    public void addSource(Result source) {
        resultsVector.add(source);
    }

    public Vector getSources() {
        return this.resultsVector;
    }

    public String toString() {
        return getName();
    }
}