package de.hampelratte.yaggui;

import java.util.Enumeration;
import java.util.Hashtable;

public class Subcommand extends Hashtable {
    public Subcommand() {
    }

    public Subcommand(String cmdline) {
        parseCmdline(cmdline);
    }

    protected void parseCmdline(String cmdline) {
        int valuestart = 0;
        int stop = cmdline.indexOf(" ");

        // extract and cut off the subcommand identifier
        String subcommand = "";
        try {
            subcommand = cmdline.substring(valuestart, stop);
            cmdline = cmdline.substring(stop, cmdline.length());
        } catch (Exception e) {
            subcommand = cmdline;
        }
        this.put("command", subcommand);
        try {
            while (true) {
                valuestart = cmdline.indexOf("(");
                if (valuestart < 0)
                    break;

                while (cmdline.charAt(valuestart - 1) == '\\') {
                    valuestart = cmdline.indexOf("(", valuestart + 1);
                }
                stop = cmdline.indexOf(")", valuestart);
                while (cmdline.charAt(stop - 1) == '\\') {
                    stop = cmdline.indexOf(")", stop + 1);
                }
                int keystart = cmdline.lastIndexOf(" ", valuestart);

                String key = cmdline.substring(keystart + 1, valuestart);
                String value = cmdline.substring(valuestart + 1, stop);

                // delete all \
                StringBuffer sb = new StringBuffer(value);
                for (int i = 0; i < sb.length(); i++) {
                    if (sb.charAt(i) == '\\')
                        sb.deleteCharAt(i);
                }
                value = sb.toString();

                cmdline = cmdline.substring(stop, cmdline.length());
                put(key, value);
            }
        } catch (Exception e) {
            Logger.getLogger().error(e);
            e.printStackTrace();
        }
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        Enumeration enumeration = this.keys();
        while (enumeration.hasMoreElements()) {
            Object keyObj = enumeration.nextElement();
            String key = (String) keyObj;
            String value = (String) this.get(keyObj);
            sb.append(key);
            sb.append('(');
            sb.append(value);
            sb.append(") ");
        }
        return sb.toString();
    }
}