package de.hampelratte.yaggui.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

import de.hampelratte.yaggui.gui.sortabletable.SortableTable;
import de.hampelratte.yaggui.gui.sortabletable.SortableTableHeaderRenderer;
import de.hampelratte.yaggui.gui.sortabletable.SortableTableModel;
/**
 * 
 * @author hampelratte@users.sf.net
 *
 */
public class FilePanel extends AbstractPanel {
    private JPanel statusbar = new JPanel();

    private JLabel status = new JLabel(" ");

    private SortableTable table;

    private SortableTableModel model;

    public FilePanel(JPanel parent) {
        super(parent);
        setBorder("Shared files");

        String[] columnNames = { "File", "Hash", "Size" };
        int[] columnWidth = { 300, 300, 100 };

        table = new SortableTable();
        model = new SortableTableModel(3, table);
        table.setModel(model);
        table.setShowGrid(false);
        table.setRowHeight(20);
        table.setRowMargin(0);
        table.setShowHorizontalLines(false);
        table.setShowVerticalLines(false);
        model.setColumnIdentifiers(columnNames);

        for (int i = model.getColumnCount() - 1; i >= 0; i--) {
            DefaultTableColumnModel tcm = (DefaultTableColumnModel) table
                    .getColumnModel();
            TableColumn tc = tcm.getColumn(i);
            tc.setCellRenderer(new ShareTableCellRenderer());
        }
        SortableTableHeaderRenderer renderer = new SortableTableHeaderRenderer();
        TableColumnModel tcm = table.getColumnModel();
        int n = columnNames.length;
        for (int i = 0; i < n; i++) {
            tcm.getColumn(i).setHeaderRenderer(renderer);
            tcm.getColumn(i).setPreferredWidth(columnWidth[i]);
        }
        JScrollPane scrollpane = new JScrollPane(table);
        scrollpane.setBorder(BorderFactory.createEmptyBorder());
        table.init();
        add(scrollpane, BorderLayout.CENTER);

        statusbar.setLayout(new FlowLayout(FlowLayout.LEFT));
        statusbar.setBackground(new Color(220, 220, 220));
        statusbar.add(status);
        //add(statusbar, BorderLayout.SOUTH);
    }

    public SortableTableModel getTableModel() {
        return this.model;
    }

    public void setStatus(String status) {
        this.status.setText(status);
    }

    public void addShare(Vector tableline) {
        model.addRow(tableline);
    }

    public void resetTable() {
        model.setRowCount(0);
    }
}