package de.hampelratte.yaggui.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.table.TableCellRenderer;

public class ProgressCellRenderer extends JPanel implements TableCellRenderer {
    private JProgressBar progress = new JProgressBar(SwingConstants.HORIZONTAL);

    public ProgressCellRenderer() {
        progress.setMinimum(0);
        progress.setMaximum(100);
        progress.setStringPainted(true);

        this.setLayout(new BorderLayout());
        this.add(progress, BorderLayout.CENTER);

        JLabel dummy1 = new JLabel();
        JLabel dummy2 = new JLabel();
        JLabel dummy3 = new JLabel();
        JLabel dummy4 = new JLabel();

        dummy1.setPreferredSize(new Dimension(2, 2));
        dummy2.setPreferredSize(new Dimension(2, 2));
        dummy3.setPreferredSize(new Dimension(2, 2));
        dummy4.setPreferredSize(new Dimension(2, 2));

        this.add(dummy1, BorderLayout.NORTH);
        this.add(dummy2, BorderLayout.WEST);
        this.add(dummy3, BorderLayout.EAST);
        this.add(dummy4, BorderLayout.SOUTH);
    }

    public Component getTableCellRendererComponent(JTable table, Object value,
            boolean isSelected, boolean hasFocus, int row, int column) {
        if (value == null) {
            return this;
        } else if (value instanceof Integer) {
            progress.setValue(((Integer) value).intValue());
            progress.setString(((Integer) value).toString() + "%");
        } else {
            progress.setValue(0);
        }

        if (isSelected) {
            setBackground(UIManager.getColor("Table.selectionBackground"));
            setForeground(UIManager.getColor("Table.selectionForeground"));
        } else {
            setForeground(Color.black);
            setBackground(((row & 1) == 1 ? UIManager
                    .getColor("Statusbar.background") : Color.white));
        }

        return this;
    }
}