package de.hampelratte.yaggui.gui.sortabletable;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;

import javax.swing.Icon;

public class SortIcon implements Icon {
    private Color fillColor;

    private int size;

    private int direction;

    public static final int UP = 1;

    public static final int DOWN = -1;

    public SortIcon() {
        this(null, 10, 1);
    }

    public SortIcon(Color color, int size, int direction) {
        fillColor = color;

        this.direction = direction;
        this.size = size;
    }

    public void paintIcon(Component c, Graphics g, int x, int y) {
        if (fillColor != null) {
            int[] x_array = new int[3];
            int[] y_array = new int[3];
            int half = (int) ((double) size / 2.0);
            if (direction == 1) {
                x_array[0] = x;
                x_array[1] = x + half;
                x_array[2] = x + size;
                y_array[0] = y + size;
                y_array[1] = y;
                y_array[2] = y + size;
            } else {
                x_array[0] = x;
                x_array[1] = x + half;
                x_array[2] = x + size;
                y_array[0] = y;
                y_array[1] = y + size;
                y_array[2] = y;
            }
            g.setColor(fillColor);
            g.fillPolygon(x_array, y_array, 3);
        }
    }

    public int getIconWidth() {
        return size;
    }

    public int getIconHeight() {
        return size;
    }
}