package de.hampelratte.yaggui.gui.sortabletable;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JTable;

public class SortableTable extends JTable implements MouseListener {
    private boolean isSorted = false;

    private int sortCol = 0;

    public static final boolean ASCENDING = true;

    public static final boolean DESCENDING = false;

    private boolean sortDirection = SortableTable.DESCENDING;

    public void init() {
        for (int i = 0; i < this.getColumnCount(); i++) {
            this.getColumnModel().getColumn(i).setHeaderRenderer(
                    new SortableTableHeaderRenderer());
        }
        this.getTableHeader().addMouseListener(this);
    }

    public boolean isSorted() {
        return this.isSorted;
    }

    public int getSortColumn() {
        return this.sortCol;
    }

    public boolean getSortDirection() {
        return this.sortDirection;
    }

    public void mouseClicked(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
        this.isSorted = true;
        this.sortDirection = !this.sortDirection;
        int col = this.getTableHeader().columnAtPoint(e.getPoint());
        if (col != sortCol) {
            sortCol = col;
            sortDirection = SortableTable.ASCENDING;
        }
        ((SortableTableModel) getModel()).sort();
    }
}